//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2011)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org

#include <iostream>
#include <fstream>
#include <string>
#include "project_io.h"
#include <wx/wx.h>

using namespace std;

void projectFileAnalsis::analyzeProjectFileContent(string fileContent)
{
     long counter1=0, counterToken=0;
     char *token;
     char *tempTotalChars;
     char *tempFileString;
     char tempFileStringComplete[500];
     
     const char *totalChars=fileContent.c_str();
     tempFileStringComplete[0]='\0';
     tempTotalChars = (char*)totalChars;
    
     token = strtok((char*)tempTotalChars,"\n");
     numSurferGRIDS=atoi(token);
    
     surferGRIDS=new wxString[numSurferGRIDS];
     
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     strcat(tempFileStringComplete, "Slices:\n");

     
     for(counter1=0;counter1<numSurferGRIDS; counter1++)
     {
            token = strtok((char*)tempTotalChars,"\n");
            surferGRIDS[counter1]=token;
            counterToken=strlen(token)+1;
            tempTotalChars=tempTotalChars+counterToken;

     }
//     surferGRIDS=wxString(tempFileStringComplete);

     token = strtok((char*)tempTotalChars,"\n");
     horAngle3D=token;
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     token = strtok((char*)tempTotalChars,"\n");
     vertAngle3D=token;
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     token = strtok((char*)tempTotalChars,"\n");
     horScale3D=token;
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     token = strtok((char*)tempTotalChars,"\n");
     vertScale3D=token;
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     token = strtok((char*)tempTotalChars,"\n");
     offset3D=token;
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     token = strtok((char*)tempTotalChars,"\n");
     fileStringCrossSectionLine=token;
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     token = strtok((char*)tempTotalChars,"\n");
     horScale2D=token;
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     token = strtok((char*)tempTotalChars,"\n");
     vertScale2D=token;
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     token = strtok((char*)tempTotalChars,"\n");
     xCoordinate1D=token;
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     token = strtok((char*)tempTotalChars,"\n");
     yCoordinate1D=token;
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     token = strtok((char*)tempTotalChars,"\n");
     vertScale1D=token;
}

void projectFileAnalsis::analyzeVBoreFileContent(string fileVBore)
{
    long counter1=0, counterToken=0, i;
    char *token;
    char *tempTotalChars;
    long numVertices=0;
    double xDist=0, yDist=0;   
     
    const char *totalChars=fileVBore.c_str();
    tempTotalChars = (char*)totalChars;
    token = strtok((char*)tempTotalChars,"\n");
    counterToken=strlen(token)+1;
    tempTotalChars=tempTotalChars+counterToken;
 
    token = strtok((char*)tempTotalChars,",");
    xCoordVBore=token;
    counterToken=strlen(token)+1;
    tempTotalChars=tempTotalChars+counterToken;
    token = strtok((char*)tempTotalChars,"\n");
    yCoordVBore=token;

}
