//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2011)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org


#include "viewer_gui1Frm.h"

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
#include "Images/viewer_gui1Frm_WxBitmapButton1_XPM.xpm"
#include "Images/viewer_gui1Frm_WxBitmapButtonCSLineFileLoad_XPM.xpm"
////Header Include End

#include "project_io.h"
#include "AttLayers.h"
#include <iostream>
#include <fstream>
#include <string>

using namespace std;
//----------------------------------------------------------------------------
// viewer_gui1Frm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(viewer_gui1Frm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(viewer_gui1Frm::OnClose)
	EVT_MENU(ID_MNU_OPENPROJECT_1002, viewer_gui1Frm::Mnuopenproject1002Click)
	EVT_MENU(ID_MNU_SAVEPROJECT_1003, viewer_gui1Frm::Mnusaveproject1003Click)
	EVT_MENU(ID_MNU_EXIT_1004, viewer_gui1Frm::Mnuexit1004Click)
	EVT_MENU(ID_MNU_ADDSURFERGRID_1006, viewer_gui1Frm::Mnuaddsurfergr1006Click)
	EVT_MENU(ID_MNU_ADDESRIGRID_1007, viewer_gui1Frm::Mnuaddesrigr1007Click)
	EVT_MENU(ID_MNU_ADDXYZDATA_1009, viewer_gui1Frm::Mnuaddxyzdata1009Click)
	EVT_MENU(ID_MNU_DELETEFROMPROJECT_1010, viewer_gui1Frm::Mnudeletefromproject1010Click)
	EVT_LISTBOX(ID_WXLISTBOXLAYERNAMES,viewer_gui1Frm::WxListBoxLayerNamesSelected)
	EVT_BUTTON(ID_WXBITMAPBUTTON1,viewer_gui1Frm::WxBitmapButton1Click)
	EVT_BUTTON(ID_WXBUTTONVBORECREATESHOW,viewer_gui1Frm::WxButtonVBoreCreateShowClick)
	EVT_BUTTON(ID_WXBITMAPBUTTONCSLINEFILELOAD,viewer_gui1Frm::WxBitmapButtonCSLineFileLoadClick)
	EVT_BUTTON(ID_WXBUTTONCREATECS,viewer_gui1Frm::WxButtonCreateCSClick)
	EVT_BUTTON(ID_WXBUTTONCS3D,viewer_gui1Frm::WxButton1Click)
END_EVENT_TABLE()
////Event Table End

viewer_gui1Frm::viewer_gui1Frm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

viewer_gui1Frm::~viewer_gui1Frm()
{
}

void viewer_gui1Frm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	wxInitAllImageHandlers();   //Initialize graphic format handlers

	WxNotebook1 = new wxNotebook(this, ID_WXNOTEBOOK1, wxPoint(0, 2), wxSize(250, 300), wxNB_DEFAULT);

	WxNoteBookPage1 = new wxPanel(WxNotebook1, ID_WXNOTEBOOKPAGE1, wxPoint(4, 24), wxSize(242, 272));
	WxNotebook1->AddPage(WxNoteBookPage1, wxT("3D View"));

	WxButtonCS3D = new wxButton(WxNoteBookPage1, ID_WXBUTTONCS3D, wxT("Create && Show"), wxPoint(53, 222), wxSize(92, 25), 0, wxDefaultValidator, wxT("WxButtonCS3D"));

	WxEditHorizAngle = new wxTextCtrl(WxNoteBookPage1, ID_WXEDITHORIZANGLE, wxT("70"), wxPoint(160, 5), wxSize(50, 20), 0, wxDefaultValidator, wxT("WxEditHorizAngle"));

	WxEditVertAngle = new wxTextCtrl(WxNoteBookPage1, ID_WXEDITVERTANGLE, wxT("30"), wxPoint(160, 35), wxSize(50, 20), 0, wxDefaultValidator, wxT("WxEditVertAngle"));

	WxEditHorScale = new wxTextCtrl(WxNoteBookPage1, ID_WXEDITHORSCALE, wxT("10000"), wxPoint(120, 65), wxSize(60, 20), 0, wxDefaultValidator, wxT("WxEditHorScale"));

	WxEditVertScale = new wxTextCtrl(WxNoteBookPage1, ID_WXEDITVERTSCALE, wxT("5000"), wxPoint(120, 95), wxSize(60, 20), 0, wxDefaultValidator, wxT("WxEditVertScale"));

	WxEditOffsetSl = new wxTextCtrl(WxNoteBookPage1, ID_WXEDITOFFSETSL, wxT("100"), wxPoint(120, 145), wxSize(60, 20), 0, wxDefaultValidator, wxT("WxEditOffsetSl"));

	WxStaticText1 = new wxStaticText(WxNoteBookPage1, ID_WXSTATICTEXT1, wxT("Horizontal Rotation (0-360):"), wxPoint(5, 10), wxDefaultSize, 0, wxT("WxStaticText1"));

	WxStaticText2 = new wxStaticText(WxNoteBookPage1, ID_WXSTATICTEXT2, wxT("Vertical Rotation (0 - 90):"), wxPoint(5, 40), wxDefaultSize, 0, wxT("WxStaticText2"));

	WxStaticText3 = new wxStaticText(WxNoteBookPage1, ID_WXSTATICTEXT3, wxT("Horizontal Scale: 1 : "), wxPoint(5, 70), wxDefaultSize, 0, wxT("WxStaticText3"));

	WxStaticText4 = new wxStaticText(WxNoteBookPage1, ID_WXSTATICTEXT4, wxT("Vertical Scale: 1 : "), wxPoint(5, 100), wxDefaultSize, 0, wxT("WxStaticText4"));

	WxStaticText5 = new wxStaticText(WxNoteBookPage1, ID_WXSTATICTEXT5, wxT("Offset Layers [m]:"), wxPoint(5, 150), wxDefaultSize, 0, wxT("WxStaticText5"));

	WxNoteBookPage2 = new wxPanel(WxNotebook1, ID_WXNOTEBOOKPAGE2, wxPoint(4, 24), wxSize(242, 272));
	WxNotebook1->AddPage(WxNoteBookPage2, wxT("2D View"));

	WxStaticText7 = new wxStaticText(WxNoteBookPage2, ID_WXSTATICTEXT7, wxT("Horizontal Scale 1 : "), wxPoint(7, 87), wxDefaultSize, 0, wxT("WxStaticText7"));

	WxStaticText8 = new wxStaticText(WxNoteBookPage2, ID_WXSTATICTEXT8, wxT("Vertical Scale 1 : "), wxPoint(7, 112), wxDefaultSize, 0, wxT("WxStaticText8"));

	WxStaticText9 = new wxStaticText(WxNoteBookPage2, ID_WXSTATICTEXT9, wxT("Get Vertex Coordinates from Text File:"), wxPoint(6, 13), wxDefaultSize, 0, wxT("WxStaticText9"));

	WxEdit1 = new wxTextCtrl(WxNoteBookPage2, ID_WXEDIT1, wxT("c:\\"), wxPoint(8, 40), wxSize(146, 24), 0, wxDefaultValidator, wxT("WxEdit1"));

	WxEdit2 = new wxTextCtrl(WxNoteBookPage2, ID_WXEDIT2, wxT("10000"), wxPoint(105, 84), wxSize(60, 22), 0, wxDefaultValidator, wxT("WxEdit2"));

	WxEditVertScaleCS = new wxTextCtrl(WxNoteBookPage2, ID_WXEDITVERTSCALECS, wxT("5000"), wxPoint(105, 110), wxSize(60, 22), 0, wxDefaultValidator, wxT("WxEditVertScaleCS"));

	WxButtonCreateCS = new wxButton(WxNoteBookPage2, ID_WXBUTTONCREATECS, wxT("Create && Show"), wxPoint(66, 201), wxSize(127, 28), 0, wxDefaultValidator, wxT("WxButtonCreateCS"));

	wxBitmap WxBitmapButtonCSLineFileLoad_BITMAP (viewer_gui1Frm_WxBitmapButtonCSLineFileLoad_XPM);
	WxBitmapButtonCSLineFileLoad = new wxBitmapButton(WxNoteBookPage2, ID_WXBITMAPBUTTONCSLINEFILELOAD, WxBitmapButtonCSLineFileLoad_BITMAP, wxPoint(167, 42), wxSize(31, 23), wxBU_AUTODRAW, wxDefaultValidator, wxT("WxBitmapButtonCSLineFileLoad"));

	WxNoteBookPage3 = new wxPanel(WxNotebook1, ID_WXNOTEBOOKPAGE3, wxPoint(4, 24), wxSize(242, 272));
	WxNotebook1->AddPage(WxNoteBookPage3, wxT("1D View"));

	WxEditVBoreXCoord = new wxTextCtrl(WxNoteBookPage3, ID_WXEDITVBOREXCOORD, wxT("0.0"), wxPoint(15, 35), wxSize(100, 24), 0, wxDefaultValidator, wxT("WxEditVBoreXCoord"));

	WxEditVBoreYCoord = new wxTextCtrl(WxNoteBookPage3, ID_WXEDITVBOREYCOORD, wxT("0.0"), wxPoint(130, 35), wxSize(100, 24), 0, wxDefaultValidator, wxT("WxEditVBoreYCoord"));

	WxStaticText6 = new wxStaticText(WxNoteBookPage3, ID_WXSTATICTEXT6, wxT("X-Coordinate:"), wxPoint(20, 15), wxDefaultSize, 0, wxT("WxStaticText6"));

	WxStaticTextVBoreYCoord = new wxStaticText(WxNoteBookPage3, ID_WXSTATICTEXTVBOREYCOORD, wxT("Y-Coordinate:"), wxPoint(135, 15), wxDefaultSize, 0, wxT("WxStaticTextVBoreYCoord"));

	WxStaticTextVBoreholeVertScale = new wxStaticText(WxNoteBookPage3, ID_WXSTATICTEXTVBOREHOLEVERTSCALE, wxT("Vertical Scale: 1 : "), wxPoint(13, 150), wxDefaultSize, 0, wxT("WxStaticTextVBoreholeVertScale"));

	WxEditVBoreholeVertScale = new wxTextCtrl(WxNoteBookPage3, ID_WXEDITVBOREHOLEVERTSCALE, wxT("200"), wxPoint(100, 145), wxSize(96, 24), 0, wxDefaultValidator, wxT("WxEditVBoreholeVertScale"));

	WxStaticTextVBoreholeGetCoordFRomFile = new wxStaticText(WxNoteBookPage3, ID_WXSTATICTEXTVBOREHOLEGETCOORDFROMFILE, wxT("Get Coordinates from ASCII-File:"), wxPoint(20, 80), wxDefaultSize, 0, wxT("WxStaticTextVBoreholeGetCoordFRomFile"));

	WxEditVBoreholeGetDataFromFile = new wxTextCtrl(WxNoteBookPage3, ID_WXEDITVBOREHOLEGETDATAFROMFILE, wxT("c:\\"), wxPoint(15, 100), wxSize(176, 24), 0, wxDefaultValidator, wxT("WxEditVBoreholeGetDataFromFile"));

	WxButtonVBoreCreateShow = new wxButton(WxNoteBookPage3, ID_WXBUTTONVBORECREATESHOW, wxT("Create && Show"), wxPoint(70, 204), wxSize(103, 27), 0, wxDefaultValidator, wxT("WxButtonVBoreCreateShow"));

	wxBitmap WxBitmapButton1_BITMAP (viewer_gui1Frm_WxBitmapButton1_XPM);
	WxBitmapButton1 = new wxBitmapButton(WxNoteBookPage3, ID_WXBITMAPBUTTON1, WxBitmapButton1_BITMAP, wxPoint(200, 100), wxSize(32, 26), wxBU_AUTODRAW, wxDefaultValidator, wxT("WxBitmapButton1"));

	wxArrayString arrayStringFor_WxListBoxLayerNames;
	WxListBoxLayerNames = new wxListBox(this, ID_WXLISTBOXLAYERNAMES, wxPoint(250, 2), wxSize(178, 285), arrayStringFor_WxListBoxLayerNames, wxLB_SINGLE | wxLB_HSCROLL);
	WxListBoxLayerNames->Append(wxT("Slices:"));

	WxOpenFileDialogVBorehole =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.bna"), wxOPEN);

	WxSaveFileDialogProjectFile =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.prj"), wxSAVE);

	WxOpenProjFileDialog =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.prj"), wxOPEN);

	WxOpenFileDialogCSLine =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.bna"), wxOPEN);

	WxMenuBar1 = new wxMenuBar();
	wxMenu *ID_MNU_FILE_1001_Mnu_Obj = new wxMenu(0);
	ID_MNU_FILE_1001_Mnu_Obj->Append(ID_MNU_OPENPROJECT_1002, wxT("Open Project"), wxT(""), wxITEM_NORMAL);
	ID_MNU_FILE_1001_Mnu_Obj->Append(ID_MNU_SAVEPROJECT_1003, wxT("Save Project"), wxT(""), wxITEM_NORMAL);
	ID_MNU_FILE_1001_Mnu_Obj->Append(ID_MNU_EXIT_1004, wxT("Exit"), wxT(""), wxITEM_NORMAL);
	WxMenuBar1->Append(ID_MNU_FILE_1001_Mnu_Obj, wxT("File"));
	
	wxMenu *ID_MNU_SURFACES_1005_Mnu_Obj = new wxMenu(0);
	ID_MNU_SURFACES_1005_Mnu_Obj->Append(ID_MNU_ADDSURFERGRID_1006, wxT("Add Surfer GRID"), wxT(""), wxITEM_NORMAL);
	ID_MNU_SURFACES_1005_Mnu_Obj->Append(ID_MNU_ADDESRIGRID_1007, wxT("Add ESRI GRID"), wxT(""), wxITEM_NORMAL);
	ID_MNU_SURFACES_1005_Mnu_Obj->Append(ID_MNU_ADDXYZDATA_1009, wxT("Add XYZ Raster Data"), wxT(""), wxITEM_NORMAL);
	ID_MNU_SURFACES_1005_Mnu_Obj->Append(ID_MNU_DELETEFROMPROJECT_1010, wxT("Delete from project"), wxT(""), wxITEM_NORMAL);
	WxMenuBar1->Append(ID_MNU_SURFACES_1005_Mnu_Obj, wxT("Surfaces"));
	
	wxMenu *ID_MNU_HELP_1008_Mnu_Obj = new wxMenu(0);
	WxMenuBar1->Append(ID_MNU_HELP_1008_Mnu_Obj, wxT("Help"));
	SetMenuBar(WxMenuBar1);

	/* Surfer ASCII Grid
	*/
	WxOpenFileDialogSurferGRID =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.grd"), wxOPEN);

	SetTitle(wxT("MO2GEO Viewer"));
	SetIcon(wxNullIcon);
	SetSize(8,8,442,333);
	Center();
	
	////GUI Items Creation End
}

void viewer_gui1Frm::OnClose(wxCloseEvent& event)
{
	Destroy();
}


/*
 * WxButton1Click
 */
void viewer_gui1Frm::WxButton1Click(wxCommandEvent& event)
{
	// insert your code here
	wxString horAngle, vertAngle, horScale, vertScale, offsetSlice, fNGrid, fNGridsAll, totalString;

	
	horAngle=WxEditHorizAngle->GetValue();
	vertAngle=WxEditVertAngle->GetValue();
	horScale=WxEditHorScale->GetValue();
	vertScale=WxEditVertScale->GetValue();
	offsetSlice=WxEditOffsetSl->GetValue();
	int numberLayers=WxListBoxLayerNames->GetCount();
	
	totalString<<(numberLayers-1)<<"\n";
	for(int i=1;i<numberLayers;i++)
	{
        fNGrid=WxListBoxLayerNames->GetString(i);
        fNGridsAll<<"SG "<<fNGrid<<"\n";
    }
	totalString<<fNGridsAll;
	totalString<<horAngle<<"\n";
	totalString<<vertAngle<<"\n";
	totalString<<horScale<<"\n";
	totalString<<vertScale<<"\n";
	totalString<<offsetSlice<<"\n";

    ofstream outFile("out3D.prj");
    outFile<<totalString;
    outFile.close();
	
    system("viewer1.exe out3D.prj");
}


/*
 * Mnuopenproject1002Click
 */
void viewer_gui1Frm::Mnuopenproject1002Click(wxCommandEvent& event)
{
	// insert your code here
	wxString horAngle, vertAngle, horScale, vertScale, offsetSlice, 
        filePathNameCS, vertScaleCS, horizScaleCS, 
        xCoordBore, yCoordBore, filePathNameBore, vertScaleBore,
        fNGrid, fNGridsAll, projectPathName, projectFileName;
    string totalString;
    long numberLayers=0, counterLayers=0;
	char* txtNL;
	int fileDialogShow;
	txtNL="25";
	fileDialogShow=WxOpenProjFileDialog->ShowModal();
	projectPathName=WxOpenProjFileDialog->GetPath();
	
    ifstream fin(projectPathName);
    getline(fin, totalString,'\t');
    fin.close();
    projectFileAnalsis projFileAna;
    projFileAna.analyzeProjectFileContent(totalString);
    numberLayers=projFileAna.getNumberSurferGRIDS();
    for(counterLayers=0;counterLayers<numberLayers;counterLayers++)
    {
        fNGrid=projFileAna.getStrSurferGRIDS(counterLayers);
        WxListBoxLayerNames->Append(fNGrid);
    }
    WxEditHorizAngle->SetValue(projFileAna.getStrHorAngle3D());
    WxEditVertAngle->SetValue(projFileAna.getStrVertAngle3D());
    WxEditHorScale->SetValue(projFileAna.getStrHorScale3D());
    WxEditVertScale->SetValue(projFileAna.getStrVertScale3D());
    WxEditOffsetSl->SetValue(projFileAna.getStrOffset3D());
    WxEdit1->SetValue(projFileAna.getStrCSLine());
    WxEdit2->SetValue(projFileAna.getStrHorScale2D());
    WxEditVertScaleCS->SetValue(projFileAna.getStrVertScale2D());
    WxEditVBoreXCoord->SetValue(projFileAna.getStrXCoordinate1D());
    WxEditVBoreYCoord->SetValue(projFileAna.getStrYCoordinate1D());
    WxEditVBoreholeVertScale->SetValue(projFileAna.getStrVertScale1D());
}

/*
 * Mnuexit1004Click
 */
void viewer_gui1Frm::Mnuexit1004Click(wxCommandEvent& event)
{
	// insert your code here
	Destroy();
}

/*
 * Mnuaddsurfergr1006Click
 */
void viewer_gui1Frm::Mnuaddsurfergr1006Click(wxCommandEvent& event)
{
	// insert your code here
	wxString pathSurferGRID, fNGrid, fNGridsAll;
	int gridOpenShow, nL;
	gridOpenShow=WxOpenFileDialogSurferGRID->ShowModal();
	pathSurferGRID=WxOpenFileDialogSurferGRID->GetPath();
	WxListBoxLayerNames->AppendString(pathSurferGRID);
	nL=WxListBoxLayerNames->GetCount();
	for (int i=1;i<nL;i++)
	{
        fNGrid=WxListBoxLayerNames->GetString(i);
        fNGridsAll<<fNGrid<<"\n";
    }
}

/*
 * WxListBoxLayerNamesSelected
 */
void viewer_gui1Frm::WxListBoxLayerNamesSelected(wxCommandEvent& event)
{
	// insert your code here
	wxString numList, layerName, layerCols, totalAttributes;
	int nL;
	nL=WxListBoxLayerNames->GetSelection();
	numList=WxListBoxLayerNames->GetString(nL);
    attribLayers* dialogAttL = new attribLayers(NULL);
    dialogAttL->ShowModal();
    layerName=dialogAttL->getNameLayer();
    layerCols=dialogAttL->getColLayer();
    totalAttributes=numList<<" "<<layerName<<" "<<layerCols;
    WxListBoxLayerNames->SetString(nL,totalAttributes);
}


/*
 * Mnuaddesrigr1007Click
 */
void viewer_gui1Frm::Mnuaddesrigr1007Click(wxCommandEvent& event)
{
	wxMessageBox ("Sorry, function not implemented yet");
}

/*
 * Mnuaddxyzdata1009Click
 */
void viewer_gui1Frm::Mnuaddxyzdata1009Click(wxCommandEvent& event)
{
	wxMessageBox ("Sorry, function not implemented yet");
}

/*
 * Mnudeletefromproject1010Click
 */
void viewer_gui1Frm::Mnudeletefromproject1010Click(wxCommandEvent& event)
{
	wxMessageBox ("All GRIDs will be deleted");
	WxListBoxLayerNames->Clear();
	WxListBoxLayerNames->AppendString("Slices:");
}

/*
 * WxButtonVBoreCreateShowClick
 */
void viewer_gui1Frm::WxButtonVBoreCreateShowClick(wxCommandEvent& event)
{
	// insert your code here
	wxString xCoordBore, yCoordBore, filePathNameBore, vertScaleBore, fNGrid, fNGridsAll, totalStringVBore;
	
	xCoordBore=WxEditVBoreXCoord->GetValue();
	yCoordBore=WxEditVBoreYCoord->GetValue();
	filePathNameBore=WxEditVBoreholeGetDataFromFile->GetValue();
	vertScaleBore=WxEditVBoreholeVertScale->GetValue();
	int numberLayers=WxListBoxLayerNames->GetCount();
	
	totalStringVBore<<(numberLayers-1)<<"\n";
	for(int i=1;i<numberLayers;i++)
	{
        fNGrid=WxListBoxLayerNames->GetString(i);
        fNGridsAll<<"SG "<<fNGrid<<"\n";
    }
	totalStringVBore<<fNGridsAll;
	totalStringVBore<<xCoordBore<<"\n";
	totalStringVBore<<yCoordBore<<"\n";
	totalStringVBore<<vertScaleBore<<"\n";

    ofstream outFile("out1D.prj");
    outFile<<totalStringVBore;
    outFile.close();
	
    system("viewer1D.exe out1D.prj");
}

/*
 * WxButtonCreateCSClick
 */
void viewer_gui1Frm::WxButtonCreateCSClick(wxCommandEvent& event)
{
	// insert your code here
	wxString filePathNameCS, vertScaleCS, horizScaleCS, fNGrid, fNGridsAll, totalStringCS;

	filePathNameCS=WxEdit1->GetValue();
	vertScaleCS=WxEditVertScaleCS->GetValue();
	horizScaleCS=WxEdit2->GetValue();
	int numberLayers=WxListBoxLayerNames->GetCount();
	
	totalStringCS<<(numberLayers-1)<<"\n";
	for(int i=1;i<numberLayers;i++)
	{
        fNGrid=WxListBoxLayerNames->GetString(i);
        fNGridsAll<<"SG "<<fNGrid<<"\n";
    }
	totalStringCS<<fNGridsAll;
	totalStringCS<<filePathNameCS<<"\n";
	totalStringCS<<horizScaleCS<<"\n";
	totalStringCS<<vertScaleCS<<"\n";

    ofstream outFile("out2D.prj");
    outFile<<totalStringCS;
    outFile.close();

    system("viewer2D.exe out2D.prj");
}

/*
 * Mnusaveproject1003Click
 */
void viewer_gui1Frm::Mnusaveproject1003Click(wxCommandEvent& event)
{
	
	wxString horAngle, vertAngle, horScale, vertScale, offsetSlice, 
        filePathNameCS, vertScaleCS, horizScaleCS, 
        xCoordBore, yCoordBore, filePathNameBore, vertScaleBore,
        fNGrid, fNGridsAll, totalString;
    
    // data for 3D view
	horAngle=WxEditHorizAngle->GetValue();
	vertAngle=WxEditVertAngle->GetValue();
	horScale=WxEditHorScale->GetValue();
	vertScale=WxEditVertScale->GetValue();
	offsetSlice=WxEditOffsetSl->GetValue();
	int numberLayers=WxListBoxLayerNames->GetCount();
	
	totalString<<(numberLayers-1)<<"\n";
	for(int i=1;i<numberLayers;i++)
	{
        fNGrid=WxListBoxLayerNames->GetString(i);
        fNGridsAll<<fNGrid<<"\n";
    }
	totalString<<fNGridsAll;
	totalString<<horAngle<<"\n";
	totalString<<vertAngle<<"\n";
	totalString<<horScale<<"\n";
	totalString<<vertScale<<"\n";
	totalString<<offsetSlice<<"\n";
	
	//data for 2D view
	filePathNameCS=WxEdit1->GetValue();
	vertScaleCS=WxEditVertScaleCS->GetValue();
	horizScaleCS=WxEdit2->GetValue();
	totalString<<filePathNameCS<<"\n";
	totalString<<horizScaleCS<<"\n";
	totalString<<vertScaleCS<<"\n";
	
	//data for 1D view
	xCoordBore=WxEditVBoreXCoord->GetValue();
	yCoordBore=WxEditVBoreYCoord->GetValue();
	filePathNameBore=WxEditVBoreholeGetDataFromFile->GetValue();
	vertScaleBore=WxEditVBoreholeVertScale->GetValue();
	totalString<<xCoordBore<<"\n";
	totalString<<yCoordBore<<"\n";
	totalString<<vertScaleBore<<"\n";
	
	wxString pathSaveProjectFile;
	int projectFileOpenShow;
	projectFileOpenShow=WxSaveFileDialogProjectFile->ShowModal();
	pathSaveProjectFile=WxSaveFileDialogProjectFile->GetPath();
	ofstream outProjectFile(pathSaveProjectFile);
	outProjectFile<<totalString;
    outProjectFile.close();
}

/*
 * WxEdit1ClickUrl
 */
//void viewer_gui1Frm::WxEdit1ClickUrl(wxTextUrlEvent& event)
//{
//	// insert your code here
//	wxString pathCSLineBNA;
//	int pathCSLineOpenShow;
//	pathCSLineOpenShow=WxOpenFileDialogCSLine->ShowModal();
//	pathCSLineBNA=WxOpenFileDialogCSLine->GetPath();
//	WxEdit1->SetValue(pathCSLineBNA);
//}

/*
 * WxBitmapButtonCSLineFileLoadClick
 */
void viewer_gui1Frm::WxBitmapButtonCSLineFileLoadClick(wxCommandEvent& event)
{
	// insert your code here
	wxString pathCSLineBNA;
	int pathCSLineOpenShow;
	pathCSLineOpenShow=WxOpenFileDialogCSLine->ShowModal();
	pathCSLineBNA=WxOpenFileDialogCSLine->GetPath();
	WxEdit1->SetValue(pathCSLineBNA);
}

/*
 * WxBitmapButton1Click
 */
void viewer_gui1Frm::WxBitmapButton1Click(wxCommandEvent& event)
{
	// insert your code here
	wxString pathVBoreBNA, vBoreXCoord, vBoreYCoord;
	string totalString;
	int pathVBoreOpenShow;
	pathVBoreOpenShow=WxOpenFileDialogVBorehole->ShowModal();
	pathVBoreBNA=WxOpenFileDialogVBorehole->GetPath();
	WxEditVBoreholeGetDataFromFile->SetValue(pathVBoreBNA);
	
    ifstream fin(pathVBoreBNA);
    getline(fin, totalString,'\t');
    fin.close();
    projectFileAnalsis vBoreFileAna;
    vBoreFileAna.analyzeVBoreFileContent(totalString);
    vBoreXCoord=vBoreFileAna.getStrXCoordVBore();
    vBoreYCoord=vBoreFileAna.getStrYCoordVBore();
    WxEditVBoreXCoord->SetValue(vBoreXCoord);
    WxEditVBoreYCoord->SetValue(vBoreYCoord);
}
