//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2010)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org

#include <iostream>
#include <fstream>
#include <string>
#include "get_projectFile.h"

using namespace std;

void getProjectFile::setFile(char file_load[])
{
       projectFile=file_load;
}

void getProjectFile::getLinesProjectFile()
{
     ifstream fin(projectFile);
     getline(fin, projectFileContent,'\t');
     fin.close();
}

void getProjectFile::analyzeProjectFileContent()
{
     long counter1=0, counterToken=0, i;
     char *token;
     char *tempTotalChars;
     long numSlices=0;
     double xDist=0, yDist=0;   
     double a;
     char seps[]=" ,\t\\n";
     
     const char *totalChars=projectFileContent.c_str();
     tempTotalChars = (char*)totalChars;

     token = strtok((char*)tempTotalChars,"\n");
     numSlices=atoi(token);
//     numSlices=numSlices+1;
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     numberSlices=numSlices;
     fileType=new char*[numSlices];
     filePathName=new char*[numSlices];
     layerName=new char*[numSlices];
     r=new long[numSlices];
     g=new long[numSlices];
     b=new long[numSlices];
     
     for(counter1=0;counter1<numSlices; counter1++)
     {
            token = strtok((char*)tempTotalChars," ");
            fileType[counter1]=token;
            counterToken=strlen(token)+1;
            tempTotalChars=tempTotalChars+counterToken;
            token = strtok((char*)tempTotalChars," ");
            filePathName[counter1]=token;
            //substitute backslash by double backslash
            counterToken=strlen(token)+1;
            tempTotalChars=tempTotalChars+counterToken;
            token = strtok((char*)tempTotalChars," ");
            layerName[counter1]=token;
            counterToken=strlen(token)+2;
            tempTotalChars=tempTotalChars+counterToken;
            token = strtok((char*)tempTotalChars,",");
            r[counter1]=atol(token);
            counterToken=strlen(token)+1;
            tempTotalChars=tempTotalChars+counterToken;
            token = strtok((char*)tempTotalChars,",");
            g[counter1]=atol(token);
            counterToken=strlen(token)+1;
            tempTotalChars=tempTotalChars+counterToken;
            token = strtok((char*)tempTotalChars,")");
            b[counter1]=atol(token);
            counterToken=strlen(token)+1;
            tempTotalChars=tempTotalChars+counterToken;
            cout<<filePathName[counter1]<<endl;
     }

//params[0]=70;
//params[1]=30;
//params[2]=10000;
//params[3]=2500;
//params[4]=100;
     
     int in;
     token = strtok((char*)tempTotalChars,"\n");
     counterToken=1;
     tempTotalChars=tempTotalChars+counterToken;
     token = strtok((char*)tempTotalChars,"\n");
     params[0]=atof(token);//X-Coordinate
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     token = strtok((char*)tempTotalChars,"\n");
     params[1]=atof(token);//Y-Coordinate
     counterToken=strlen(token)+1;
     tempTotalChars=tempTotalChars+counterToken;
     token = strtok((char*)tempTotalChars,"\n");
     params[2]=atof(token);//vertical scale
//     counterToken=strlen(token)+1;
//     tempTotalChars=tempTotalChars+counterToken;
//     token = strtok((char*)tempTotalChars,"\n");
//     params[3]=atof(token);//vertical scale
//     counterToken=strlen(token)+1;
//     tempTotalChars=tempTotalChars+counterToken;
//     token = strtok((char*)tempTotalChars,"\n");
//     params[4]=atof(token);//offset layers
//     counterToken=strlen(token)+1;
//     tempTotalChars=tempTotalChars+counterToken;
}

long getProjectFile::getNumberSlices()
{
    return numberSlices;
}

char* getProjectFile::getPathFileSlice(int numSlice)
{
    return filePathName[numSlice];
}

string getProjectFile::getNameSlice(int numSlice)
{
    return layerName[numSlice];
}

long getProjectFile::getRed(int numSlice)
{
    return r[numSlice];
}

long getProjectFile::getGreen(int numSlice)
{
    return g[numSlice];
}

long getProjectFile::getBlue(int numSlice)
{
    return b[numSlice];
}

void getProjectFile::getProjectionParams(double p[])
{
    for(int i=0;i<3;i++)
    {
        p[i]=params[i];
    }
}
