//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2010)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org


#include <iostream>
#include <string>

using namespace std;

class getProjectFile
{
    public:
        getProjectFile(){};
        ~getProjectFile(){};
        void setFile(char file_load[]);
        void getLinesProjectFile();
        void analyzeProjectFileContent();
        void getLineFileContent();
        void analyzeLineFileContent();
        void getProjectionParams(double p[]);
        long getNumberSlices();
        char* getPathFileSlice(int numSlice);
        string getNameSlice(int numSlice);
        long getRed(int numSlice);
        long getGreen(int numSlice);
        long getBlue(int numSlice);
        long getNumberVertices();
        double getVertexX(int numVertex);
        double getVertexY(int numVertex);

    private:
        char* projectFile;
        long numberSlices;
        long numberVertices;
        string projectFileContent;
        string lineFileContent;
        char **fileType;
        char **filePathName;
        char **layerName;
        long *r;
        long *g;
        long *b;
        double *vertexXCoord;
        double *vertexYCoord;
        char* linFile;
        double params[2];
        double horScale;
        double vertScale;
};
